<template>
  <div>
    <UApp>
      <NuxtLayout>
        <NuxtPage v-if="hasJwt" />
        <div class="p-2 flex h-screen w-screen items-center justify-center" v-else>
          <h1>Please wait...</h1>
        </div>
      </NuxtLayout>
    </UApp>
  </div>
</template>

<script setup lang="ts">
const colorMode = useColorMode();
const { locale } = useI18n();

const { onLogin } = useApollo();

const hasJwt = ref(false);

onMounted(() => {
  window.addEventListener("message", ({data}) => {
    switch (data.action) {
      case "colorMode": {
        colorMode.value = data.data;
        break;
      }
      case "locale": {
        locale.value = data.data;
        break;
      }
      case "setJwt": {
        console.log(`Received JWT: ${data.data}`);
        onLogin(data.data);
        hasJwt.value = true;
        break;
      }
    }
  });

  // Fetch JWT every 5 minutes (valid for 10 minutes)
  window.setInterval(() => {
    window.top?.postMessage({ action: "requestJwt" }, "*");
  }, 1000 * 60 * 5);

  window.top?.postMessage({ action: "requestJwt" }, "*");
});
</script>

<style>
@import "tailwindcss";
@import "@nuxt/ui";

@theme {
  --color-nirvati-50: #f5e6fa;
  --color-nirvati-100: #ebccf5;
  --color-nirvati-200: #d699eb;
  --color-nirvati-300: #c166e0;
  --color-nirvati-400: #ac33d6;
  --color-nirvati-500: #800080;
  --color-nirvati-600: #660066;
  --color-nirvati-700: #4c004c;
  --color-nirvati-800: #330033;
  --color-nirvati-900: #310031;
  --color-nirvati-950: #190019;

  --color-citadel-50: #fff8eb;
  --color-citadel-100: #fde9c8;
  --color-citadel-200: #fbd28c;
  --color-citadel-300: #f9b450;
  --color-citadel-400: #f7931a;
  --color-citadel-500: #f1760f;
  --color-citadel-600: #d65309;
  --color-citadel-700: #b1360c;
  --color-citadel-800: #902b10;
  --color-citadel-900: #762311;
  --color-citadel-950: #440f04;
}
</style>
